require File.expand_path(File.dirname(__FILE__) + '/../../../lib/TNR360/components/dependencies.rb')

class LdsArea

  @browser
  @parentBlock
  @idArea=nil
  @title=nil
  @visible=false
  @exists=false
  @collapsible=false
  @collapsed=false
  @current_element


  #constructor
  def initialize(browser, idArea, block=nil)
    @browser =browser
    @idArea=idArea
    @parentBlock=block
    update
    @exists
  end


  #refresh object status from browser
  def refresh
    #Look for element in browser
    @current_element= findElement @idArea
    #update other data
    update
    @exists
  end

  #private method to update/save the status of the object
  def update
    @exists=false

    #Look for element in browser
    @current_element||= findElement @idArea

    #fill @title
    @title=@current_element.legend(:index => 0).span(:index => 0).text
    #fill visible
    @visible=@current_element.visible?
    #fill isCollapsible
    if @current_element.legend(:index => 0).divs.length>0
      @collapsible=true
    else
      @collapsible=false
    end
    #fill isCollapsed
    if @collapsible
      @collapsed=@current_element.class_name.include? "collapsed"
    else
      @collapsed=false
    end

    #everything exists
    @exists=true
  end

  #method locate current element
  def findElement idElement
    begin
      #if element not yet available in screen, wait for some time
      if @parentBlock != nil
        @parentBlock.getElement.div(:index => 2).fieldset(:id, idElement).wait_until_present(10)
        @current_element=@parentBlock.getElement.div(:index => 2).fieldset(:id, idElement)
      end
    rescue

      raise "Element "+idElement+" Not Found"

    ensure
      #rien dans finally pour ce cas
      if @parentBlock == nil
        if @browser.fieldset(:id, idElement).wait_until_present(10)
          count=@browser.fieldsets(:id, idElement).length
        end
        if count==0
          raise "Element "+idElement+" Not Found"
        else
          if count >1
            raise "Several Elements with id "+idElement+"  Found, specify block"
          end
        end
        @current_element=@browser.fieldset(:id, idElement).when_present
      end
    end
    @current_element
  end


  #print object
  def to_s
    "\n***** Area *****"+
        "\nIdArea : "+ no_null(@idArea)+
        "\nIdParentBlock : "+(no_null(@parentBlock)=="" ? "" : @parentBlock.getIdBlock)+
        "\nTitle : "+ no_null(@title)+
        "\nCollapsible :"+ bool_no_null(@collapsible.to_s)+
        "\nCollapsed :"+ bool_no_null(@collapsed.to_s)+
        "\nVisible : "+ bool_no_null(@visible.to_s)+
        "\nExists : "+ bool_no_null(@exists.to_s)+
        "\n**********"
  end


  ##LdsScreen Actions
  def reverse_collapse
    if (@collapsible)
      @current_element.legend(:index => 0).div(:index => 0).when_present.click
    end
    update
  end

  def collapse
    if (@collapsible && !@collapsed)
      @current_element.legend(:index => 0).div(:index => 0).when_present.click
    end
    update
  end

  def expand
    if (@collapsible && @collapsed)
      @current_element.legend(:index => 0).div(:index => 0).when_present.click
    end
    update
  end

  ####Getters

  def getElement
    @current_element
  end

  def getIdArea
    @idArea
  end

  def getParentBloc
    @parentBlock
  end

  def getTitle
    @title
  end

  def isCollapsible?
    @collapsible
  end

  def isCollapsed?
    @collapsed
  end

  def isVisible?
    @visible
  end

  def isExist?
    @exists
  end

  #private method list
  private :update
end




