require File.expand_path(File.dirname(__FILE__) + '/../../../lib/TNR360/components/dependencies.rb')

class LdsCheckbox
  @browser
  @idField=nil
  @idBlock=nil
  @idScreen=nil
  @exists=false
  @nature=nil
  @value=nil
  @visible=false
  @editable=false
  @label=nil
  @mandatory=false
  @checked=false
  @current_element
  #constructor
  def initialize(browser,idField,idBlock=nil,idScreen=nil)
    @browser =browser
    @idField= idField
    @idBlock=idBlock
    @idScreen=idScreen
    update
    @exists
  end

  #refresh object status from browser
  def refresh
    #Look for element in browser
    @current_element= findElement @idField
    #update other data
    update
    @exists
  end

  #private method to update/save the status of the object
  def update
    @exists=false
    #Look for element in browser
    @current_element||= findElement @idField
    #fill label
    @label=@browser.label(:xpath => "//label[contains(@for,'"+@idField+"')]").when_present.text
    @checked= @current_element.set?
    @value=@current_element.set?
    #fill visible
    @visible=@current_element.visible?
    #fill editable
    @editable=!(@current_element.readonly?)
    #everything exists
    @exists=true
  end

  #method locate current element
  def findElement idElement

    # @browser.div(:id => idElement).radio(:index => 0)
    @current_element=nil

    #wait for screen to become visible (find screen forcefully)
    proc=Proc.new {isScreenDisplayed }
    puts 'Screen found = '+ force_find_element(proc).to_s

    #wait for screen to become visible (find screen forcefully)
    proc=Proc.new {elementExists?(idElement) }
    @exists=force_find_element(proc)
    puts 'CheckBox found = '+@exists.to_s

    if (@browser.divs(:id => idElement).length>1 && @idBlock!=nil)
      #utiliser le id bloc
      @bloc=LdsBlock.new(@browser, @idBlock)
      @current_element=@bloc.getElement.div(:id => idElement).checkbox(:index => 0).when_present
    else
      if (@browser.divs(:id => idElement).length>1)
        @browser.divs(:id => idElement).each do |field|
          if field.visible?
            @current_element=field.checkbox(:index => 0)
            break
          end
        end
      else
        @current_element=@browser.div(:id => idElement).checkbox(:index => 0).when_present
      end
    end
    if @current_element.visible?
      puts 'element is visible'
    else
      puts 'element is NOT visible'
    end
    @current_element
  end

  def elementExists?(idElement)
    #this method assumes the screen/tab is already loaded
    oneIsVisible=false
    #if element not yet available in screen, wait for some time
    if (!@browser.div(:id => idElement).checkbox(:index => 0).exists?)
      @browser.div(:id => idElement).checkbox(:index => 0).when_present(10)
      oneIsVisible=true
    else
      if (!@browser.divs(:id => idElement).visible?)
        @browser.div(:id => idElement).each do |field|
          if field.visible?
            oneIsVisible=true
            break
          end
        end
        if !oneIsVisible
          @browser.div(:id => idElement).checkbox(:index => 0).when_present(10)
          oneIsVisible=true
        end
      end
    end
    oneIsVisible
  end

  def isScreenDisplayed
    if (@idScreen!=nil)
      @scr=LdsScreen.new(@browser, @idScreen)
      @scr.isVisible?
    else
      false
    end
  end
  #print object
  def to_s
    "\n***** CheckBox *****"+
     "\nId : "+no_null(@idField.to_s) +
     "\nIdBlock : "+ no_null(@IdBlock.to_s)+
     "\nIdScreen : "+ no_null(@IdScreen.to_s)  +
     "\nValue : "+  no_null(@value.to_s)+
     "\nLabel : "+  no_null(@label.to_s)+
     "\nVisible : "+  no_null(@visible.to_s)+
     "\nEditable : "+ no_null(@editable.to_s)+
     "\nExists : "+  no_null(@exists.to_s)+
     "\nNature : "+  no_null(@nature.to_s)+
      "\nChecked : "+ no_null(@checked.to_s)+
    "\n**********"
  end

  ##LdsScreen Actions
  def check
    @browser.div(:id => @idField).checkbox(:index => 0).when_present.set
    @checked=true
    @exists=true
    update
  end

  def uncheck
    @browser.div(:id => @idField).checkbox(:index => 0).when_present.clear
    @checked=false
    @exists=true
    update
  end


  ####Getters

  def getElement
    @current_element
  end

  def getIdentifier
    @idField
  end
  def getIdBlock
    @idBlock
  end
  def getIdScreen
    @idScreen
  end
  def isChecked
  puts @checked
 end

  def getValue
 @value
  end

  def getLabel
   @label
  end

  def isVisible?
   @visible
   end

    def isEditable?
    @editable
    end

   def isExist
    @exists
   end
   #private method list
  private :update
  end