require File.expand_path(File.dirname(__FILE__) + '/../../../lib/TNR360/components/dependencies.rb')

class LdsColumn

  @browser
  @idBlock=nil
  @idColumn=nil
  @isVisible=false
  @orderInVisible=nil
  @Label=nil


  #constructor
  def initialize(browser, idColumn, block, orderInVisible=nil)
    @browser =browser
    @parentBlock=block
    @idColumn=idColumn
    @orderInVisible=orderInVisible
    update
    @exists
  end


  #refresh object status from browser
  def refresh
    #Look for element in browser
    @current_element= findElement @idColumn
    #update other data
    update
    @exists
  end

  #private method to update/save the status of the object
  def update
    @exists=false
    #Look for element in browser
    @current_element||= findElement @idColumn
    #fill @label
    @label=@current_element.div(:index => 0).span(:index => 0).text
    #fill visible
    @visible=@current_element.visible?
    #fill idColumn
    #@idColumn=@current_element.class_name
    #everything exists
    #changeVisibility "Payment" ,"Reject"
    @exists=true
  end


  #method locate current element
  def findElement idElement
    begin
      #if element not yet available in screen, wait for some time
      if @parentBlock != nil
        @parentBlock.getElement.div(:class,"std-fieldset-bwrap").tr(:index => 0).td(:xpath => "//td[contains(@class,'"+idElement+"')]").wait_until_present(10)
        @current_element=@parentBlock.getElement.div(:class,"std-fieldset-bwrap").tr(:index => 0).td(:xpath => "//td[contains(@class,'"+idElement+"')]")
        #@current_element=@parentBlock.getElement.div(:index => 2).tr(:index=>0).td(:class => "x-grid3-header x-grid3-hd x-grid3-cell x-grid3-td-"+idElement)
      end
    rescue

      raise "Column "+idElement+" Not Found"

    ensure
      #rien dans finally pour ce cas
      if @parentBlock == nil
        if @browser.td(:xpath => "//td[contains(@class,'"+idElement+"')]").wait_until_present(10)
          count=@browser.tds(:xpath => "//td[contains(@class,'"+idElement+"')]").length
        end
        if count==0
          raise "Column "+idElement+" Not Found"
        else
          if count >1
            raise "Several Elements with id "+idElement+"  Found, specify block"
          end
        end
        @current_element=@browser.td(:xpath => "//td[contains(@class,'"+idElement+"')]").when_present
      end
    end
    @current_element
  end

  #print object
  def to_s

    "\n***** Column *****"+
        "\nIdParentBlock : "+(no_null(@parentBlock)=="" ? "" : @parentBlock.getIdBlock)+
        "\nIdColumn: "+ no_null(@idColumn)+
        "\nLabel : "+ no_null(@label)+
        "\nIsVisible : "+ bool_no_null(@visible.to_s)+
        "\nOrderInVisible :"+ no_null(@orderInVisible.to_s)+
        "\n**********"


  end


  def sortAscending label
    @current_element.hover
    @current_element.a(:index=>0).when_present.click
    @browser.a(:id, label+"sort-asc-text").when_present.click
  end

  def sortDescending label
    @current_element.hover
    @current_element.a(:index=>0).when_present.click
    @browser.a(:id, label+"sort-desc-text").when_present.click
  end

  def changeVisibility columnLabel ,elementTobeDisplayedLabel
    @current_element.hover
    @current_element.a(:index=>0).when_present.click
    @browser.a(:id, columnLabel+"change-column-visibility").hover
    @browser.div(:id,"Payment-change-visibility-menu").div(:class,"x-menu-list").a(:id,columnLabel+"-change-visibility-"+elementTobeDisplayedLabel).click
  end
  def displayColumns columnLabel
    @current_element.hover
    @current_element.a(:index=>0).when_present.click
    @browser.a(:id, columnLabel+"change-column-visibility").hover
  end
  ####Getters

  def getElement
    @current_element
  end

  def getIdBlock
    @idBlock
  end

  def getClassColumn
    @idColumn
  end

  def getLabel
    @label
  end

  def isVisible?
    @isVisible
  end


  def isExist?
    @exists
  end

  #private method list
  private :update
end




