require File.expand_path(File.dirname(__FILE__) + '/../../../lib/TNR360/components/dependencies.rb')

class LdsGrid < LdsBlock
  @paginated_grid=false
  @editable_grid=false
  @check_selected_line=false
  @selected=false
  @goToPageSuccess=false
  @fkClickCell=false
  @doubleClickLine=false
  @cellValue=nil
  @isNext=false
  @isPrevious=false
  @isFirst=false
  @isLast=false
  @isCellEditable=false


  #constructor
  def initialize(browser, idBlock, idScreen=nil)
    super(browser, idBlock, idScreen)
    update
    @exists
  end

  def update
    super
    check_paginated
    check_editable
  end

  #check if paginated grid or not
  def check_paginated
    @paginated_grid=@current_element.class_name.include?"paging-remote"
  end
  #check if editable grid or not
  def check_editable
    @editable_grid=@current_element.div(:class, "std-fieldset-bwrap").div(:class, "std-fieldset-tbar").exists?
  end

  #*************************column methods****************

  def extractDisplayedColumns
    count=1
    @columns=Array.new
    while count <= @current_element.div(:class, "std-fieldset-bwrap").tr(:index => 0).tds.length
      #iterate through list of columns
      @current_element.div(:class, "std-fieldset-bwrap").tr(:index => 0).tds.each do |column|
        @columns << LdsColumn.new(@browser, column.class_name.split("-").last, self, count)
        count +=1
      end
    end
    puts column_to_s
  end

  def extractAllColumns columnId
    count=0
    @allColumns=Array.new
    @column=LdsColumn.new(@browser, columnId, self, count)
    @column.displayColumns (@column.getLabel)
    columnsNbr=@browser.div(:id, "Payment-change-visibility-menu").div(:class, "x-menu-list").as.length
    while count< columnsNbr
      @allColumns<< @browser.div(:id, "Payment-change-visibility-menu").div(:class, "x-menu-list").a(:index => count).class_name.split("-").last
      count+=1
    end
  end

  def extractColumnValues (idColumn)
    lines=@current_element.div(:class, "std-fieldset-bwrap").div(:class, "x-grid3-body").tables.length
    if (lines!=0)
      ind =1
      @columnValues=Array.new
      @labelColumn= @current_element.div(:class, "std-fieldset-bwrap").div(:class, "x-grid3-body").table(:index => 0).td(:xpath => "//td[contains(@class,'"+idColumn+"')]", :index => 0).text
      while ind <= lines
        @columnValues << @current_element.div(:class, "std-fieldset-bwrap").div(:class, "x-grid3-body").table(:index => ind-1).td(:xpath => "//td[contains(@class,'"+idColumn+"')]", :index => ind).text
        #@current_element.div(:class, "std-fieldset-bwrap").div(:class, "x-grid3-body").table(:index => lineIndex).td(:xpath => "//td[contains(@class,'"+idColumn+"')]", :index => lineIndex)
        ind +=1
      end
    else
      puts "grid is empty"
    end
  end

  #***************************line methods******************
  def extractLine (lineIndex)
    #iterate through number of lines
    if @current_element.div(:class, "std-fieldset-bwrap").div(:class, "x-grid3-body").table(:index => lineIndex-1).exists?
      @current_element.div(:class, "std-fieldset-bwrap").div(:class, "x-grid3-body").table(:index => lineIndex-1).parent
    else
      puts "Line not found"
    end

  end

  def checkSelectedLine (lineIndex)
    #@selected_line= @current_element.div(:class,"std-fieldset-bwrap").div(:class, "x-grid3-body").table(:index => lineIndex-1).parent.class_name.include? "selected"
    @line= extractLine lineIndex
    @check_selected_line=@line.class_name.include? "selected"
    puts "\nIsSelectedLine : "+ bool_no_null(@check_selected_line.to_s)

  end

  def selectLine (lineIndex)
    #@selected_line= @current_element.div(:class,"std-fieldset-bwrap").div(:class, "x-grid3-body").table(:index => lineIndex-1).parent.class_name.include? "selected"
    @line= extractLine lineIndex
    @line.click
    checkSelectedLine lineIndex
  end

  #********************************line Actions methods**************
  def lineDoubleClick (lineIndex)
    #@selected_line= @current_element.div(:class,"std-fieldset-bwrap").div(:class, "x-grid3-body").table(:index => lineIndex-1).parent.class_name.include? "selected"
    @line= extractLine lineIndex
    if (@line!=nil)
      #if firefox, do the double click trick
      custom_double_click @browser , @line
      sleep($wait_time)
    end

    if (!@browser.div(:id => @idBlock).visible?)
      @doubleClickLine=true
    end

    puts "\nDoubleClick : "+ bool_no_null(@doubleClickLine.to_s)
  end



  #*******************************Cell methods**********************
  def extractCellByLineAndColumnIndex (lineIndex, idColumn)
    if @current_element.div(:class, "std-fieldset-bwrap").div(:class, "x-grid3-body").table(:index => lineIndex-1).td(:xpath => "//td[contains(@class,'"+idColumn+"')]", :index => lineIndex).exists?
      @current_element.div(:class, "std-fieldset-bwrap").div(:class, "x-grid3-body").table(:index => lineIndex-1).td(:xpath => "//td[contains(@class,'"+idColumn+"')]", :index => lineIndex)
    else
      puts "Cell not found"
    end
  end

  def extractCellValue (lineIndex, idColumn)
    @cell=extractCellByLineAndColumnIndex lineIndex, idColumn
    if (@cell!=nil)
      @cellValue=@cell.text
    end
    puts "\nCell value : "+ no_null(@cellValue)
  end

  def getCellLines (idColumn, cellValue)
    extractColumnValues idColumn
    @lineCell=Array.new
    if (@columnValues != nil)
      i=1
      @columnValues.each do |column|
        if column==cellValue
          @lineCell<< i
        end
        i+=1
      end
    end
    if (@lineCell!=nil)
      puts "\n*****Lines that contain : "+ no_null(cellValue) + "*****"
      @lineCell.each { |value| puts value }
    end
  end

  def isCellEditable? (lineIndex, idColumn)
    @cell=extractCellByLineAndColumnIndex lineIndex, idColumn
    if (@cell!=nil)
      if (@cell.class_name.include? "editable")
        @isCellEditable=true
      end
    end
    puts "\nCellEditable :"+ bool_no_null(@isCellEditable.to_s)
  end

  #***************************Cell Actions methods****************************
  def clickFkInGrid (lineIndex, idColumn)
    @cell=extractCellByLineAndColumnIndex lineIndex, idColumn
    if (@cell!=nil)
      @cell.click
      sleep($wait_time)
    end
    if (!@browser.div(:id => @idBlock).visible?)
      @fkClickCell=true
    end
    puts "\nFkClick :"+ bool_no_null(@fkClickCell.to_s)
  end

  #******************************Grid Actions**********************

  def goFirst
    @current_element.div(:class, "std-fieldset-bbar").img(:index => 0).click
    #sleep($large_wait_time)
    pageNumber=@current_element.div(:class, "std-fieldset-bbar").td(:class => "x-toolbar-cell", :index => 4).text_field.when_present($large_wait_time).value
    if (pageNumber.to_i==1)
      @isFirst=true
    end
    puts "\nIsFirstPage : "+ bool_no_null(@isFirst.to_s)
  end

  def goPrevious
    pageNumber=@current_element.div(:class, "std-fieldset-bbar").td(:class => "x-toolbar-cell", :index => 4).text_field.value
    @current_element.div(:class, "std-fieldset-bbar").img(:index => 1).click
    #sleep($large_wait_time)
    newPageNumber=@current_element.div(:class, "std-fieldset-bbar").td(:class => "x-toolbar-cell", :index => 4).text_field.when_present($large_wait_time).value
    if (newPageNumber.to_i==pageNumber.to_i-1)
      @isPrevious=true
    end
    puts "\nIsPreviousPage : "+ bool_no_null(@isPrevious.to_s)
  end

  def goNext
    pageNumber=@current_element.div(:class, "std-fieldset-bbar").td(:class => "x-toolbar-cell", :index => 4).text_field.value
    @current_element.div(:class, "std-fieldset-bbar").img(:index => 2).click
    #sleep($large_wait_time)
    newPageNumber=@current_element.div(:class, "std-fieldset-bbar").td(:class => "x-toolbar-cell", :index => 4).text_field.when_present($large_wait_time).value
    if (newPageNumber.to_i==pageNumber.to_i+1)
      @isNext=true
    end
    puts "\nIsNextPage : "+ bool_no_null(@isNext.to_s)
  end

  def goLast
    lastPageNumber=@current_element.div(:class, "std-fieldset-bbar").td(:class => "x-toolbar-cell", :index => 5).div(:index => 0).text.split(" ").last
    @current_element.div(:class, "std-fieldset-bbar").img(:index => 3).click
    #sleep($large_wait_time)
    newPageNumber=@current_element.div(:class, "std-fieldset-bbar").td(:class => "x-toolbar-cell", :index => 4).text_field.when_present($large_wait_time).value
    if (newPageNumber.to_i==lastPageNumber.to_i)
      @isLast=true
    end
    puts "\nIsLastPage : "+ bool_no_null(@isLast.to_s)
  end

  def goToPage pageNbr
    @current_element.div(:class, "std-fieldset-bbar").td(:class => "x-toolbar-cell", :index => 4).text_field.set pageNbr
    @browser.send_keys :return
    #sleep($wait_time)
    newPageNumber=@current_element.div(:class, "std-fieldset-bbar").td(:class => "x-toolbar-cell", :index => 4).text_field.when_present($wait_time).value
    if (newPageNumber.to_i==pageNbr)
      @goToPageSuccess=true
    end
    puts "\nGoToPageSuccess : "+ bool_no_null(@goToPageSuccess.to_s)
  end

  def clickRefresh
    @current_element.div(:class, "std-fieldset-bbar").img(:index => 4).click
  end

  #Add  action in a grid
  def addLine (*args)
    @current_element.div(:class, "std-fieldset-tbar").table(:xpath => "//table[contains(@id"",'"+"add"+"')]").when_present.click
    args.each do |arg_item|
    @current_element.div(:class,"x-form-field-wrap  x-spinner-field fwk-number x-component").text_field.set arg_item
    @browser.send_keys :tab
    # def sub_method(idScreen,*args)
    #   args.each do |arg_item|
    #     puts arg_item.inspect
    #     puts arg_item.class.inspect
    #   end
     end
  end

  #Delete action in a grid
    def deleteLine (lineIndex)
    extractLine lineIndex
    selectLine lineIndex
    @current_element.div(:class, "std-fieldset-tbar").table(:xpath => "//table[contains(@id,'"+"remove"+"')]").when_present.click
  end

  #Modify a cell in a grid
  def modifyCell(lineIndex, columnId, newValue)
    @cellToModify=extractCellByLineAndColumnIndex lineIndex, columnId
    custom_double_click @browser , @cellToModify
    @cellToModify.div(:class,"fwk-weekDaysListGrid-dayName").send_keys newValue
    @browser.send_keys :return
  end

  #print object
  def to_s
    super.to_s +
        "\n***** Grid *****"+
        "\nIsPaginated : "+ bool_no_null(@paginated_grid.to_s)+
        "\nIsEditable : "+ bool_no_null(@editable_grid.to_s)+
        "\n**********"
  end


  def columnValues_to_s
    if (@columnValues!=nil)
      puts "\n*****Values of column : "+ no_null(@labelColumn) + "*****"
      @columnValues.each { |value| puts value }
    end
  end


  def allColumns_to_s
    if (@allColumns!=nil)
      @allColumns.each { |value| puts value }
    end
  end

  def column_to_s
    if (@columns != nil)
      @columns.each do |column|
        column.to_s
      end
    end
  end


  def getPaginated?
    @paginated_grid
  end

  def getEditable?
    @editable_grid
  end

  def isSelectedLine?
    @check_selected_line
  end

  def getCellValue
    @cellValue
  end

  def getCellEditable?
    @isCellEditable
  end

  #private method list
  private :update
end

