require File.expand_path(File.dirname(__FILE__) + '/../../../lib/TNR360/components/dependencies.rb')


class LdsTextField

  @browser
  @idField=nil
  @idBlock=nil
  @idScreen=nil
  @value=nil
  @label=nil
  @mandatory=false
  @visible=false
  @editable=false
  @exists=false

  @current_element


  #constructor
  def initialize(browser, idField, idBlock=nil, idScreen=nil)
    @browser =browser
    @idField= idField
    @idBlock=idBlock
    @idScreen=idScreen
    update
    @exists
  end

  #refresh object status from browser
  def refresh
    #Look for element in browser
    @current_element= findElement @idField
    #update other data
    update
    @exists
  end

  #private method to update/save the status of the object
  def update
    @exists=false

    #Look for element in browser
    @current_element||= findElement @idField
    #fill value
    @value=@current_element.value
    #fill label
    @label=@current_element.name
    #fill isMandatory #TODO
    ## @mandatory=@browser.label(:for, @idField).when_present.style.include? "bold"
    #fill visible
    @visible=@current_element.visible?
    #fill editable
    @editable=!(@current_element.readonly?)
    #everything exists
    @exists=true
  end

  #method locate current element
  def findElement idElement
    @current_element=nil

    #wait for screen to become visible (find screen forcefully)
    proc=Proc.new { isScreenDisplayed }
    puts 'Screen found = '+ force_find_element(proc).to_s

    #wait for screen to become visible (find screen forcefully)
    proc=Proc.new { elementExists?(idElement) }
    @exists=force_find_element(proc)
    puts 'Element found = '+@exists.to_s


    if (@browser.text_fields(:id => idElement).length>1 && @idBlock!=nil)
      #utiliser le id bloc
      @bloc=LdsBlock.new(@browser, @idBlock)
      @current_element=@bloc.getElement.text_field(:id, idElement).when_present
    else
      if (@browser.text_fields(:id => idElement).length>1)
        @browser.text_fields(:id => idElement).each do |field|
          if field.visible?
            @current_element=field
            break
          end
        end
      else
        @current_element=@browser.text_field(:id, idElement).when_present
      end
    end
    if @current_element.visible?
      puts 'element is visible'
    else
      puts 'element is NOT visible'
    end
    @current_element
  end


  def isScreenDisplayed
    if (@idScreen!=nil)
      @scr=LdsScreen.new(@browser, @idScreen)
      @scr.isVisible?
    else
      false
    end
  end

  def elementExists?(idElement)
    #this method assumes the screen/tab is already loaded
    oneIsVisible=false
    #if element not yet available in screen, wait for some time
    if (!@browser.text_field(:id => idElement).exists?)
      @browser.text_field(:id => idElement).when_present($wait_time.to_i)
      oneIsVisible=true
    else
      if (!@browser.text_field(:id => idElement).visible?)
        @browser.text_fields(:id => idElement).each do |field|
          if field.visible?
            oneIsVisible=true
            break
          end
        end
        if !oneIsVisible
          @browser.text_field(:id => idElement).when_present($wait_time.to_i)
          oneIsVisible=true
        end
      else
        oneIsVisible=true
      end
    end
    oneIsVisible
  end

  #print object
  def to_s
    "\n***** Text_Field *****"+
        "\nId : "+no_null(@idField) +
        "\nIdBlock : "+ no_null(@IdBlock)+
        "\nIdScreen : "+ no_null(@IdScreen) +
        "\nValue : "+ no_null(@value)+
        "\nLabel : "+ no_null(@label)+
        "\nMandatory : "+ no_null(@mandatory.to_s)+
        "\nVisible : "+ no_null(@visible.to_s)+
        "\nEditable : "+ no_null(@editable.to_s)+
        "\nExists : "+ no_null(@exists.to_s)+
        "\n**********"
  end


  ##LdsScreen Actions
  def fill (value)
    @browser.text_field(:id => @idField).when_present.set(value)
    update
  end


  ####Getters

  def getElement
    @current_element
  end

  def getIdentifier
    @idField
  end

  def getIdBlock
    @idBlock
  end

  def getIdScreen
    @idScreen
  end

  def getValue
    @value
  end

  def getLabel
    @label
  end

  def isMandatory?
    @mandatory
  end

  def isVisible?
    @visible
  end

  def isEditable?
    @editable
  end

  def isExist?
    @exists
  end

  #private method list
  private :update, :elementExists?
end



